//+------------------------------------------------------------------+
//|                                                   Pip Target.mq4 |
//|                                                 Copyright  2010 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 YellowGreen
#property indicator_width1 3

//--- input parameters
extern string TimeFrame      = "Current time frame";
extern int    ATRPeriod		  = 12;
extern int 	  HistoryLength  = 60;
//--- buffers
double PipTarget[];
// Globals
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,PipTarget); SetIndexStyle(0,DRAW_HISTOGRAM);
         HistoryLength = MathMax(HistoryLength,1);
         ATRPeriod     = MathMax(ATRPeriod,1);
         timeFrame     = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" ("+ATRPeriod+")"+" ("+HistoryLength+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//
//
//
//

double workAtr[];

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(MathMax(Bars-counted_bars,timeFrame/Period()),Bars-1);
           if (ArraySize(workAtr)!=HistoryLength) ArrayResize(workAtr,HistoryLength);

   //
   //
   //
   //
   //

   int yold =-1;   
   for (i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      if (yold != y)
      {
         yold=y;     
            for (int k=0; k<HistoryLength; k++) workAtr[k] = iATR(NULL,timeFrame,ATRPeriod,y+k);
            double min = workAtr[ArrayMinimum(workAtr)];
            double max = workAtr[ArrayMaximum(workAtr)];
      }            
      PipTarget[i]=max+min-workAtr[0];
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
//+------------------------------------------------------------------+